#!/usr/bin/perl

$y_end     = "([BCDFGHJKLMNPQRSTVWXZ])Y\$";
$vol_con   = "([AEIOU])([BCDFGHJKLMNPEQRSTV])\$";

sub plural 
{
  local $_ = $_[0];
  s/(S|X|Z|CH|SH)$/$1es/i
  or s/$y_end/$1ies/i
  or s/$/s/i;
  return $_;   
}

sub ed
{
  local $_ = $_[0];
  s/E$/ed/i
  or s/$y_end/$1ied/i
  or s/$vol_con/$1$2$2ed/i
  or s/$/ed/;
  return $_;
}

sub ing
{
  local $_ = $_[0];
  s/E$/ing/i
  or s/$vol_con/$1$2$2ing/i
  or s/$/ing/;
  return $_;
}

sub er
{
  local $_ = $_[0];
  s/E$/er/i
  or s/$y_end/$1ier/i
  or s/$vol_con/$1$2$2er/i
  or s/$/er/;
  return $_;
}
  
sub est
{
  local $_ = $_[0];
  s/E$/est/i
  or s/$y_end/$1iest/i
  or s/$vol_con/$1$2$2est/i
  or s/$/est/i;
  return $_;
}

open F, "r/pos/part-of-speech.txt";
while (<F>) {
  ($word,$POSes) = /(.+)\t(.+)/ or die;
  $lookup{$word} = $POSes;
}

while (<STDIN>)
{
  chop;
  $word = $_;
  $_ = $lookup{$word};
  $word .= "\n";
  print $word;
  print &plural($word)         if /[NV]/;
  print &ed($word),&ing($word) if /V/;
  print &er($word),&est($word) if /[Av]/;
}

